#from urllib2 import urlopen
from Components.MenuList import MenuList
from Components.Label import Label

from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.ActionMap import NumberActionMap
from Components.Input import Input
from Components.Pixmap import Pixmap
from Components.FileList import FileList
from Screens.ChoiceBox import ChoiceBox
from Plugins.Plugin import PluginDescriptor
from Components.ActionMap import ActionMap
from Screens.InputBox import InputBox, PinInput

from twisted.web.client import getPage, downloadPage
#from Plugins.Extensions.VlcPlayer.VlcServerConfig import vlcServerConfig

from enigma import eServiceReference
from enigma import eServiceCenter
import os

######################################################################
#                                                                    #
#   DMvidsDirect    : Coded by pcd@i-have-a-dreambox, August 2010    #
#   This is free software; you can redistribute it and/or modify it. #
#   However, you are politely requested to retain these 3 lines.     #
#                                                                    #
######################################################################

HD = 0

class Vidtype(Screen):
    skin = """
		<screen position="200,200" size="350,300" title="Categories" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="345,280" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="100,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />

		</screen>"""
    def __init__(self, session):
		self.skin = Vidtype.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)

                self.ict = 0
                self.onLayoutFinish.append(self.startSession)
                self.onClose.append(self.__onClose)
		
    def __onClose(self):
	  if os.path.isfile("/usr/lib/gstreamer-0.10/libgstsouphttpsrc.soX")is True :
	        os.system("mv /usr/lib/gstreamer-0.10/libgstsouphttpsrc.soX /usr/lib/gstreamer-0.10/libgstsouphttpsrc.so")
                os.system("mv /usr/lib/gstreamer-0.10/libgstneonhttpsrc.so /usr/lib/gstreamer-0.10/libgstneonhttpsrc.soX")

    def startSession(self):
                if os.path.isfile("/usr/lib/gstreamer-0.10/libgstsouphttpsrc.so")is True :
                        os.system("mv /usr/lib/gstreamer-0.10/libgstsouphttpsrc.so /usr/lib/gstreamer-0.10/libgstsouphttpsrc.soX")
                if os.path.isfile("/usr/lib/gstreamer-0.10/libgstneonhttpsrc.soX")is True :
                        os.system("mv /usr/lib/gstreamer-0.10/libgstneonhttpsrc.soX /usr/lib/gstreamer-0.10/libgstneonhttpsrc.so")
 
                vidtype = []
                self.urltype = []
              
                vidtype.append("Search")
                vidtype.append("Top 20 music videos 1-10")
                vidtype.append("Top 20 music videos 11-20")
                vidtype.append("Other music videos")
                vidtype.append("More music videos")
                vidtype.append("News")
                vidtype.append("More news")
                vidtype.append("Funny")
                vidtype.append("HD videos 1")
                vidtype.append("HD videos 2")
                vidtype.append("Video games 1")
                vidtype.append("Video games 2")
                vidtype.append("Arts - Creative")
                vidtype.append("Documentary")
                vidtype.append("Science - Space")
                vidtype.append("Fashion")
              
                self.urltype.append(" ")
                self.urltype.append("http://www.dailymotion.com/daily50/")
                self.urltype.append("http://www.dailymotion.com/daily50/2")  
                self.urltype.append("http://www.dailymotion.com/user/RadarMusicVideos") 
                self.urltype.append("http://www.dailymotion.com/user/RadarMusicVideos/2")               
                self.urltype.append("http://www.dailymotion.com/en/channel/news/featured/1")
                self.urltype.append("http://www.dailymotion.com/en/channel/news/featured/2")
                self.urltype.append("http://www.dailymotion.com/rated/user/nqtv")
                self.urltype.append("http://www.dailymotion.com/hd/1")
                self.urltype.append("http://www.dailymotion.com/hd/2")
                self.urltype.append("http://www.dailymotion.com/channel/videogames/featured/1")
                self.urltype.append("http://www.dailymotion.com/channel/videogames/featured/2")
                self.urltype.append("http://www.dailymotion.com/rated-week/creative/channel/creation/1")
                self.urltype.append("http://www.dailymotion.com/playlist/xxuv8_dailymotionuk_documentary")        
                self.urltype.append("http://www.dailymotion.com/playlist/xnf6x_dailymotionuk_tech-and-science") 
                self.urltype.append("http://www.dailymotion.com/Fashion_TV/1") 
                
                self["list"].setList(vidtype)
    
    def okClicked(self):
                global HD
                itype = self["list"].getSelectionIndex()
		if itype == 0:
		        self.showCmdInputBox()
				
		elif (itype == 1) or (itype == 2):
		        url = self.urltype[itype]
		        self.session.open(Gettopvids, url)
		        
		elif (itype == 8) or (itype == 9):
		        HD = 1
		        url = self.urltype[itype]
		        self.session.open(Getvids, url)        
		        
		else:
                        url = self.urltype[itype]
		        self.session.open(Getvids, url)

    def showCmdInputBox(self):
               	self.session.openWithCallback(self.search, InputBox, title=_("Please enter seach words"), text= " ", maxSize=False, visible_width = 56, type=Input.TEXT)

    def search(self, sline):
                sline = sline.replace(" ", "+")                
                surl = "http://www.dailymotion.com/relevance/search/" + sline
#                print "surl = ", surl 
                self.session.open(Getvids, surl)

class Gettopvids(Screen):

    skin = """
		<screen position="100,100" size="550,400" title="Videos" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="500,350" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="300,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />
		</screen>"""

    def __init__(self, session, url):
		self.skin = Gettopvids.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.url = url
                self.urls = []
                self.names = []
                self.onLayoutFinish.append(self.search)
                

    def search(self):
           self["info"].setText("Downloading list...")
           furl = self.url
#           print "furl =", furl
           getPage(self.url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
           iname = []
           surl = []
           self.names = []
           self.urls = []

	   i = 0
	   j = 0
	   icount = 0
	   start = 0
           
           while i<20 :
              if i==0:  
                n0 = fpage.find('DMTITLE',start)       
                if n0<0:
                       i = i+1
                       continue 
                n1 = fpage.find('&DMTAGS',(n0+5))       
                if n1<0:
                       break
                n11 = fpage.find('dmpi_daily50_ranking_item xid', (n1+5))       
                self.names.append(j)
                self.names[j] = fpage[(n0+8):(n1)]
                self.urls.append(j)
                self.urls[j] = self.url
                start = n11+20
                i = i+1
                j = j+1
                continue
                
              else:         
                n2 = fpage.find('dmpi_daily50_ranking_item xid', start)

                if n2<0:
                       break          
                n3 = fpage.find('id="',(n2+10))
                if n3<0:
                       break
                n4 = fpage.find('"',(n3+6))
                if n4<0:
                       break      
                
                n5 = fpage.find('img src',start)       
                if n5<0:
                       break        
                n6 = fpage.find('title="',(n5+3))
                if n6<0:
                       break
                n7 = fpage.find('"',(n6+8))
                if n7<0:
                       break 
                
 
                iurl = "http://www.dailymotion.com/video/" + fpage[(n3+4):(n4)]

                self.urls.append(j)
                self.urls[j] = iurl
                iurllast = self.urls[j]
                self.names.append(j)
                self.names[j] = fpage[(n6+7):(n7)]
 #               print "i, j, self.names[j], self.urls[j] =", i, j, self.names[j], self.urls[j]                 
                j = j+1
               
                start = n7 + 5
        
                i = i+1
                
           self["info"].setText("")
           self["list"].setList(self.names)
   
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
    def okClicked(self):
		itype = self["list"].getSelectionIndex()
		url = self.urls[itype]
		self.session.open(Playvid, url)
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)
		

class Getvids(Screen):

    skin = """
		<screen position="100,100" size="550,400" title="Videos" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="500,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="300,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />
		</screen>"""

    def __init__(self, session, url):
		self.skin = Getvids.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.url = url
                self.urls = []
                self.names = []
                self.onLayoutFinish.append(self.search)
                

    def search(self):
                self["info"].setText("Downloading list...")
                furl = self.url
                print "furl =", furl
                getPage(self.url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
           iurllast = " "
           iname = []
           surl = []
           self.names = []
           self.urls = []

	   i = 0
	   j = 0
	   icount = 0
	   start = 0
	   while i<20 :
                n2 = fpage.find('dmco_link with_contex', start)
                if n2<0:
                       break 
                n3 = fpage.find('href="',(n2+10))
                if n3<0:
                       break
                n4 = fpage.find('"',(n3+9))
                if n4<0:
                       break       
     
                iurl = "http://www.dailymotion.com/" + fpage[(n3+7):(n4)]
                if iurl != iurllast:
                         self.urls.append(j)
                         self.urls[j] = iurl
                         print "j =", j
                         print "self.urls[j]=", self.urls[j]
                         print "iurllast =", iurllast
                         iurllast = self.urls[j]
                         self.names.append(j)
                         print "j 2 =", j
                         self.names[j] = fpage[(n3+20):(n4)]
                         print "j 3 =", j
                         j = j+1
#               
                start = n4 + 5
                i = i+1
                
           self["info"].setText("")
           self["list"].setList(self.names)

   
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
    def okClicked(self):
		global HD
                itype = self["list"].getSelectionIndex()
		url = self.urls[itype]
		if HD == 1:
                        self.session.open(Playvidhd, url)
                else:
                        self.session.open(Playvid, url)        
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)


class Playvid(Screen):

    def __init__(self, session, url):
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.url = url
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
                self.geturl()

    def geturl(self):
           furl = self.url
           print "furl =", furl
           getPage(self.url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
                n1 = fpage.find('videoPluginParameters', 0)
                if n1<0:
                       return
                n2 = fpage.find('http', (n1+15))
                if n2<0:
                       return                
                n3 = fpage.find('%22%', (n2+4))
                if n3<0:
                       return
                item1 = fpage[(n2+1):n3]
                n4 = fpage.find('http', (n3+5))
             
                n5 = fpage.find('%22%', (n4+4))

                url1 = fpage[n2:n3]
                url2 = fpage[n4:n5]
#                print "url2 a = ", url2
                url2 = url2.replace("%3A", ":")
                url2 = url2.replace("%5C%2F", "/") 
                url2 = url2.replace("%3F", "?")
                url2 = url2.replace("%3D", "=")
#                print "url2 b = ", url2
                
                self.url = url2
                self.name = " "
                self.test()

    def test(self):
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
                self.session.nav.stopService()
                self.play()
               	
    def play(self):
          try:
                sref = eServiceReference(4097,0,self.url)
	        self.session.nav.playService(sref)
	  except:
                return      

    def close(self):
                self.session.nav.stopService()
                self.session.nav.playService(self.srefOld)
                Screen.close(self, False)
 
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
    def okClicked(self):
		self.close()

    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)
		
class Playvidhd(Screen):

    def __init__(self, session, url):
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.url = url
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
                self.geturl()

    def geturl(self):
           furl = self.url
           print "furl =", furl
           getPage(self.url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
                n1 = fpage.find('videoPluginParameters', 0)
                if n1<0:
                       return
                n2 = fpage.find('http', (n1+15))
                if n2<0:
                       return                
                n3 = fpage.find('%22%', (n2+4))
                if n3<0:
                       return
                item1 = fpage[(n2+1):n3]
                n4 = fpage.find('http', (n3+5))
             
                n5 = fpage.find('%22%', (n4+4))
                
                n6 = fpage.find('http', (n5+5))
             
                n7 = fpage.find('%22%', (n6+6))

                url1 = fpage[n2:n3]
                url2 = fpage[n6:n7]
#                print "url2 a = ", url2
                url2 = url2.replace("%3A", ":")
                url2 = url2.replace("%5C%2F", "/") 
                url2 = url2.replace("%3F", "?")
                url2 = url2.replace("%3D", "=")
#                print "url2 b = ", url2
                
                self.url = url2
                self.name = " "
                self.test()

    def test(self):
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
                self.session.nav.stopService()
                self.play()
               	
    def play(self):
                sref = eServiceReference(4097,0,self.url)
	        self.session.nav.playService(sref)

    def close(self):
                self.session.nav.stopService()
                self.session.nav.playService(self.srefOld)
                Screen.close(self, False)
 
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
    def okClicked(self):
		self.close()

    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)
		 
 
 
def main(session, **kwargs):
        session.open(Vidtype)

def Plugins(**kwargs):
	return PluginDescriptor(name="DMvidsDirect", description="Player for Dailymotion videos", where = PluginDescriptor.WHERE_PLUGINMENU, fnc=main)

































